\documentclass[12pt]{article}

\usepackage[utf8]{inputenc}

\usepackage{xspace}

\usepackage{amsmath}

\usepackage{semantic}

\newcommand{\tezla}{\textsc{Tezla}\xspace}
\newcommand{\lrangle}[1]{\langle #1 \rangle}

\newcommand{\failed}{\mathtt{FAILED}}

\newcommand{\assign}[2]{#1~\mathtt{:=}~#2}
\newcommand{\loopi}[4]{\mathtt{LOOP}~#1~\mathtt{:=}~\phi(#2, #3)~#4}
\newcommand{\loopleft}[4]{\mathtt{LOOP\_LEFT}~#1~\mathtt{:=}~\phi(#2, #3)~#4}
\newcommand{\iter}[4]{\mathtt{ITER}~#1~\mathtt{:=}~\phi(#2, #3)~#4}
\newcommand{\map}[7]{\mathtt{MAP}~#1~\mathtt{:=}~\phi(#2, #3)~\mathtt{with}~#4~\mathtt{:=}~\phi(#5, #6)~#7}

\newcommand{\intt}{\mathtt{int}}
\newcommand{\nat}{\mathtt{nat}}
\newcommand{\timestamp}{\mathtt{timestamp}}
\newcommand{\mutez}{\mathtt{mutez}}
\newcommand{\stringt}{\mathtt{string}}
\newcommand{\pairt}[2]{\mathtt{pair}~#1~#2}
\newcommand{\bytes}{\mathtt{bytes}}
\newcommand{\keyhash}{\mathtt{key\_hash}}

\newcommand{\some}[1]{\mathtt{Some}~#1}
\newcommand{\pair}[2]{\mathtt{Pair}~(#1~#2)}
\newcommand{\none}{\mathtt{None}}
\newcommand{\elt}[2]{\mathtt{Elt}~#1~#2}
\newcommand{\unit}{\mathtt{Unit}}
\newcommand{\leftor}[1]{\mathtt{Left}~#1}
\newcommand{\rightor}[1]{\mathtt{Right}~#1}

\newcommand{\true}{\mathtt{True}}
\newcommand{\false}{\mathtt{False}}

\newcommand{\abs}[1]{\mathsf{abs}}
\newcommand{\compare}{\mathsf{compare}}
\newcommand{\getcontracttype}{\mathsf{get\_contract\_type}}
\newcommand{\length}{\mathsf{length}}

\title{\tezla Semantics}
\author{João Santos Reis}
\date{}

\begin{document}
\maketitle

\[
    \compare~v_1~v_2=\begin{cases}
        -1 \quad           & \text{if} ~ v_1 < v_2 \\
        \phantom{-}0 \quad & \text{if} ~ v_1 = v_2 \\
        \phantom{-}1 \quad & \text{if} ~ v_1 > v_2
    \end{cases}
\]

\[
    \abs \quad v=\begin{cases}
        \phantom{-}v \quad & \text{if} ~ v >= 0 \\
        -v \quad           & \text{if} ~ v < 0
    \end{cases}
\]

\section*{Variable Assignment}

\inference{\lrangle{i, s} -> \lrangle{(v_1, \ldots, v_n), s}}
{\lrangle{\assign{x_1, \ldots, x_n}{i}, s} -> s[x_1 \mapsto v_1
            \ldots x_n \mapsto v_n]}

\vspace{0.5cm}

\section*{Special Functions}

\inference{s[x] = \{ h ; < tl > \}}{\lrangle{\mathtt{hd}~x, s} -> h}

\vspace{0.5cm}

\inference{s[x] = \{ h ; < tl > \}}{\lrangle{\mathtt{tl}~x, s} -> tl}

\vspace{0.5cm}

\inference{s[x] = \leftor{v}}{\lrangle{\mathtt{unlift\_or}~x, s} -> v}

\vspace{0.5cm}

\inference{s[x] = \rightor{v}}{\lrangle{\mathtt{unlift\_or}~x, s} -> v}

\vspace{0.5cm}

\inference{s[x] = \some{v}}{\lrangle{\mathtt{unlift\_option}~x, s} -> v}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}{\lrangle{\mathtt{append}~x_1~x_2, s} ->
    \{ < v_1 > ; < v_2 > \}}

\vspace{0.5cm}

\section*{Control Structures}

\inference{s[x_1] = v \\ s[x_2] = \{ i : t_1 -> t_2 \}}
{\lrangle{\mathtt{APPLY}~x_1~x_2, s} ->
    \lrangle{\{\assign{y_0}{\mathtt{PUSH}~t_1~v} ;
        \assign{parameter}{\mathtt{PAIR}~y_0~parameter}~; i : t_2 -> t_3 \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v \\ s[x_2] = \{ i : t_1 -> t_2 \} \\ \lrangle{i, \{
        parameter \mapsto v \}} -> v'}
{\lrangle{\mathtt{EXEC}~x_1~x_2, s} -> v'}

\vspace{0.5cm}

\inference{}{\lrangle{\mathtt{FAILWITH}~x, s} -> \failed}

\vspace{0.5cm}

\inference{s[x] = \true}{\lrangle{\mathtt{IF}~x~i_1~i_2, s} -> \lrangle{i_1, s}}

\vspace{0.5cm}

\inference{s[x] = \false}{\lrangle{\mathtt{IF}~x~i_1~i_2, s} -> \lrangle{i_2, s}}

\vspace{0.5cm}

\inference{s[x] = \{ h ; < tl >\}}{\lrangle{\mathtt{IF\_CONS}~x~i_1~i_2, s} -> \lrangle{i_1, s}}

\vspace{0.5cm}

\inference{s[x] = \{\}}{\lrangle{\mathtt{IF\_CONS}~x~i_1~i_2, s} -> \lrangle{i_2, s}}

\vspace{0.5cm}

\inference{s[x] = \leftor{v}}{\lrangle{\mathtt{IF\_LEFT}~x~i_1~i_2, s} -> \lrangle{i_1, s}}

\vspace{0.5cm}

\inference{s[x] = \rightor{v}}{\lrangle{\mathtt{IF\_LEFT}~x~i_1~i_2, s} -> \lrangle{i_2, s}}

\vspace{0.5cm}

\inference{s[x] = \none}{\lrangle{\mathtt{IF\_NONE}~x~i_1~i_2, s} -> \lrangle{i_1, s}}

\vspace{0.5cm}

\inference{s[x] = \some{v}}{\lrangle{\mathtt{IF\_NONE}~x~i_1~i_2, s} -> \lrangle{i_2, s}}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v \\ s' = s[x_1 \mapsto v] \\ s'[x_1] = \{\}}
{\lrangle{\iter{x_1}{x_2}{x_3}{i}, s} -> s'}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v \\ s' = s[x_1 \mapsto v] \\ s'[x_1] = \{ h ; < tl > \}}
{\lrangle{\iter{x_1}{x_2}{x_3}{i}, s} -> \lrangle{i ; \iter{x_1}{x_2}{x_3}{i}, s'}}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v \\ s' = s[x_1 \mapsto v] \\ s'[x_1] = \{ \elt{k}{v} ; < m > \}}
{\lrangle{\iter{x_1}{x_2}{x_3}{i}, s} -> \lrangle{i ; \iter{x_1}{x_2}{x_3}{i}, s'}}

\vspace{0.5cm}

\inference{}{\mathtt{LAMBDA}~t_1~t_2~i -> \{ i : t_1 -> t_2 \}}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v \\ \lrangle{\assign{x_1}{v}, s} -> s' \\ s'[x_1] = \true}
{\lrangle{\loopi{x_1}{x_2}{x_3}{i}, s} -> \lrangle{i ; \loopi{x_1}{x_2}{x_3}{i}, s'}}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v \\ \lrangle{\assign{x_1}{v}, s} -> s' \\ s'[x_1] = \false}
{\lrangle{\loopi{x_1}{x_2}{x_3}{i}, s} -> s'}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v \\ \lrangle{\assign{x_1}{v}, s} -> s' \\ s'[x_1] = \leftor{v}}
{\lrangle{\loopleft{x_1}{x_2}{x_3}{i}, s} -> \lrangle{i ; \loopleft{x_1}{x_2}{x_3}{i}, s'}}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v \\ \lrangle{\assign{x_1}{v}, s} -> s' \\ s'[x_1] = \false}
{\lrangle{\loopleft{x_1}{x_2}{x_3}{i}, s} -> s'}

\vspace{0.5cm}

\inference{\lrangle{i_1, s} -> \lrangle{i', s'}}{\lrangle{i_1 ; i_2, s} ->
    \lrangle{i' ; i_2, s'}}

\vspace{0.5cm}

\inference{\lrangle{i_1, s} -> s'}{\lrangle{i_1 ; i_2, s} -> \lrangle{i_2, s'}}

\vspace{0.5cm}

\inference{}{\lrangle{\{\}, s} -> s}

\vspace{0.5cm}

\section*{Stack Manipulation}

\inference{}{\lrangle{\mathtt{DIG}~n} -> s}

\vspace{0.5cm}

\inference{}{\lrangle{\mathtt{DIP}~n} -> s}

\vspace{0.5cm}

\inference{}{\lrangle{\mathtt{DROP}~n} -> s}

\vspace{0.5cm}

\inference{}{\lrangle{\mathtt{DUG}~n} -> s}

\vspace{0.5cm}

\inference{s[x] = v}{\lrangle{\mathtt{DUP}~x} -> \lrangle{v, s}}

\vspace{0.5cm}

\inference{}{\lrangle{\mathtt{PUSH}~t~v, s} -> \lrangle{v, s}}

\vspace{0.5cm}

\inference{}{\lrangle{\mathtt{SWAP}} -> s}

\vspace{0.5cm}

\section*{Arithmetic Operations}

\inference{s[x] = v}{\lrangle{\mathtt{ABS} ~ x} -> \lrangle{\abs~v, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{ADD} ~ x_1 ~ x_2} -> \lrangle{v_1 + v_2, s}}

\vspace{0.5cm}

\inference{s[x_1] = (\mathtt{Pair} ~ va_1 ~ vb_1) \\ s[x_2] =
    (\mathtt{Pair} ~ va_2 ~ vb_2) \\ compare(va_1, va_2) = -1}
{\lrangle{\mathtt{COMPARE} ~ x_1 ~ x_2} -> \lrangle{-1, s}}

\vspace{0.5cm}

\inference{s[x_1] = (\mathtt{Pair} ~ va_1 ~ vb_1) \\ s[x_2] =
    (\mathtt{Pair} ~ va_2 ~ vb_2) \\ compare(va_1, va_2) = 1}
{\lrangle{\mathtt{COMPARE} ~ x_1 ~ x_2} -> \lrangle{1, s}}

\vspace{0.5cm}

\inference{s[x_1] = (\mathtt{Pair} ~ va_1 ~ vb_1) \\ s[x_2] =
    (\mathtt{Pair} ~ va_2 ~ vb_2) \\ compare(va_1, va_2) = 0}
{\lrangle{\mathtt{COMPARE} ~ x_1 ~ x_2} -> \lrangle{-1, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{COMPARE}~x_1~x_2} -> \lrangle{\compare~x_1~x_2, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = 0}
{\lrangle{\mathtt{EDIV} ~ x_1 ~ x_2} -> \lrangle{\none, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{EDIV} ~ x_1 ~ x_2} ->
    \lrangle{\some{(\pair{(v_1~/~v_2)}{(v_2~\%~v_2)})}, s}}

\vspace{0.5cm}

\inference{s[x] = 0}
{\lrangle{\mathtt{EQ}~x} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x] \neq 0}
{\lrangle{\mathtt{EQ}~x} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x] \geq 0}
{\lrangle{\mathtt{GE}~x} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x] < 0}
{\lrangle{\mathtt{GE}~x} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x] > 0}
{\lrangle{\mathtt{GT}~x} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x] \leq 0}
{\lrangle{\mathtt{GT}~x} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{INT}~x} -> \lrangle{v, s}}

\vspace{0.5cm}

\inference{s[x] = v \\ v \geq 0}
{\lrangle{\mathtt{ISNAT}~x} -> \lrangle{\some{v}, s}}

\vspace{0.5cm}

\inference{s[x] < 0}
{\lrangle{\mathtt{ISNAT}~x} -> \lrangle{\none, s}}

\vspace{0.5cm}

\inference{s[x] \leq 0}
{\lrangle{\mathtt{LE}~x} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x] > 0}
{\lrangle{\mathtt{LE}~x} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ v_2 \leq 256}
{\lrangle{\mathtt{LSL}~x_1~x_2} -> \lrangle{v_1 \ll v_2, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ v_2 > 256}
{\lrangle{\mathtt{LSL}~x_1~x_2} -> \failed}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ v_1 \leq 256}
{\lrangle{\mathtt{LSR}~x_1~x_2} -> \lrangle{v_1 \gg v_2, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ v_1 > 256}
{\lrangle{\mathtt{LSR}~x_1~x_2} -> \failed}

\vspace{0.5cm}

\inference{s[x] < 0}
{\lrangle{\mathtt{LT}~x} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x] \geq 0}
{\lrangle{\mathtt{LT}~x} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{MUL}~x_1~x_2} -> \lrangle{v_1 \times v_2, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{NEG}~x} -> \lrangle{-v, s}}

\vspace{0.5cm}

\inference{s[x] = v \\ v = 0}
{\lrangle{\mathtt{NEQ}~x} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x] = v \\ v \neq 0}
{\lrangle{\mathtt{NEQ}~x} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{SUB}~x_1~x_2} -> \lrangle{v_1 - v_2, s}}

\vspace{0.5cm}

\section*{Boolean Operations}

\inference{s[x_1] = \true \\ s[x_2] = \true}
{\lrangle{\mathtt{AND}~x_1~x_2} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = \false \\ s[x_2] = v_2}
{\lrangle{\mathtt{AND}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \false}
{\lrangle{\mathtt{AND}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{AND}~x_1~x_2} -> \lrangle{v_1~\&~v_2, s}}

\vspace{0.5cm}

\inference{s[x] = \true}
{\lrangle{\mathtt{NOT}~x} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x] = \false}
{\lrangle{\mathtt{NOT}~x} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = \true \\ s[x_2] = v_2}
{\lrangle{\mathtt{OR}~x_1~x_2} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = \false \\ s[x_2] = \true}
{\lrangle{\mathtt{OR}~x_1~x_2} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = \false \\ s[x_2] = \false}
{\lrangle{\mathtt{OR}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{OR}~x_1~x_2} -> \lrangle{v_1~|~v_2, s}}

\vspace{0.5cm}

\inference{s[x_1] = \true \\ s[x_2] = \true}
{\lrangle{\mathtt{XOR}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = \false \\ s[x_2] = \true}
{\lrangle{\mathtt{XOR}~x_1~x_2} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = \true \\ s[x_2] = \false}
{\lrangle{\mathtt{XOR}~x_1~x_2} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = \false \\ s[x_2] = \false}
{\lrangle{\mathtt{XOR}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{XOR}~x_1~x_2} -> \lrangle{v_1~\mathtt{xor}~v_2, s}}

\vspace{0.5cm}

\section*{Cryptographic Operations}

\inference{s[x] = v}
{\lrangle{\mathtt{BLAKE2B}~x} -> \lrangle{hash\_blake2b~v, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_1] = v_2 \\ s[x_1] = v_3}
{\lrangle{\mathtt{CHECK_SIGNATURE}~x_1~x_2~x_3} ->
    \lrangle{\mathsf{check\_signature}~v_1~v_2~v_3, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{HASH\_KEY}~x} -> \lrangle{\mathsf{hash\_key}~v, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{SHA256}~x} -> \lrangle{\mathsf{hash\_sha256}~v, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{SHA512}~x} -> \lrangle{\mathsf{hash\_sha512}~v, s}}

\vspace{0.5cm}

\section*{Blockchain Operations}

\inference{s[x] = v}
{\lrangle{\mathtt{ADDRESS}~x} -> \lrangle{\mathsf{address}~v, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{AMOUNT}} -> \lrangle{\mathsf{amount}, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{BALANCE}~x} -> \lrangle{\mathsf{balance}~v, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{CHAIN\_ID}~x} -> \lrangle{\mathsf{chain\_id}~v, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{ADDRESS}~x} -> \lrangle{\mathsf{address}~v, s}}

\vspace{0.5cm}

\inference{s[x] = v \\ \getcontracttype~v~t}
{\lrangle{\mathtt{CONTRACT}~t~x} -> \lrangle{\some{(\mathsf{contract}~t~v)}, s}}

\vspace{0.5cm}

\inference{s[x] = v \\ \getcontracttype~v~t_1 \\ t_1 \neq t}
{\lrangle{\mathtt{CONTRACT}~t~x} -> \lrangle{\some{(\mathsf{contract}~t~v)}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ s[x_3] = v_3 \\
    \mathsf{create_contract}~t_1~t_2~code~v_1~v_2~v_3 = (op, addr)}
{\lrangle{\mathtt{CREATE\_CONTRACT}~t_1~t_2~code~x_1~x_2~x_3} -> \lrangle{(op,
        addr), s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{IMPLICIT\_ACCOUNT}~x} ->
    \lrangle{\mathsf{implicit\_account}~v, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{NOW}} -> \lrangle{\mathsf{now}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{SELF}} -> \lrangle{\mathsf{self}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{SENDER}} -> \lrangle{\mathsf{sender}, s}}

\vspace{0.5cm}

\inference{s[x] = \some{v}}
{\lrangle{\mathtt{SET\_DELEGATE~x}} -> \lrangle{\mathsf{set\_delegate}~v, s}}

\vspace{0.5cm}

\inference{s[x] = \none}
{\lrangle{\mathtt{SET\_DELEGATE~x}} -> \lrangle{\mathsf{remove\_delegation}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{SOURCE}} -> \lrangle{\mathsf{source}, s}}

\vspace{0.5cm}

\inference{s[x] = v_1 \\ s[x_2] = v_2 \\ s[x_3] = v_3}
{\lrangle{\mathtt{TRANSFER\_TOKENS}~x_1~x_2~x_3} ->
    \lrangle{\mathsf{transfer\_tokens}~v_1~v_2~v_3, s}}

\vspace{0.5cm}

\section*{Operations on Data Structures}

\inference{s[x] = \pair{v_1}{v_2}}
{\lrangle{\mathtt{CAR}~x} -> \lrangle{v_1, s}}

\vspace{0.5cm}

\inference{s[x_1] = \pair{v_1}{v_2}}
{\lrangle{\mathtt{CDR}~x} -> \lrangle{v_2, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{CONCAT}~x_1~x_2} -> \lrangle{v_1~\hat{}~v_2, s}}

\vspace{0.5cm}

\inference{s[x] = \{\}}
{\lrangle{\mathtt{CONCAT}~x} -> \lrangle{"", s}}

\vspace{0.5cm}

\inference{s[x] = \{ h ; <tl> \} \\ s' = s[y \mapsto tl] \\ \lrangle{\mathtt{CONCAT}~y, s'}
    -> \lrangle{t, s'}}
{\lrangle{\mathtt{CONCAT}~x} -> \lrangle{h~\hat{}~t, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{CONS}~x_1~x_2} -> \lrangle{\{v_1 ; <v_2>\}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{EMPTY\_BIG\_MAP}~t_1~t_2} -> \lrangle{\{\}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{EMPTY\_MAP}~t_1~t_2} -> \lrangle{\{\}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{EMPTY\_SET}~t} -> \lrangle{\{\}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{\}}
{\lrangle{\mathtt{GET}~x_1~x_2} -> \lrangle{\none, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ \elt{k}{v} ; < m > \} \\ \compare~v_1~k
    = 1 \\ s' = s[y \mapsto m] \\ \lrangle{\mathtt{GET}~x_1~y} -> \lrangle{v_2,
        s'}}
{\lrangle{\mathtt{GET}~x_1~x_2} -> \lrangle{v_2, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ \elt{k}{v} ; < m > \} \\ \compare~v_1~k
    = 0}
{\lrangle{\mathtt{GET}~x_1~x_2} -> \lrangle{\some{v}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ \elt{k}{v} ; < m > \} \\ \compare~v_1~k
    = -1}
{\lrangle{\mathtt{GET}~x_1~x_2} -> \lrangle{\none, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{LEFT}~t~x} -> \lrangle{\mathtt{Left}~v, s}}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v_1 \\ \phi(x_5, x_6) = v_2 \\ s' = s[x_1 \mapsto v_1, x_4 \mapsto v_2] \\ s'[x_1] = \{\}}
{\lrangle{\map{x_1}{x_2}{x_3}{x_4}{x_5}{x_6}{i}, s} -> s'}

\vspace{0.5cm}

\inference{\phi(x_2, x_3) = v_1 \\ \phi(x_5, x_6) = v_2 \\ s' = s[x_1 \mapsto
        v_1, x_4 \mapsto v_2] \\ s'[x_1] = \{ h ; < tl >\}}
{\lrangle{\map{x_1}{x_2}{x_3}{x_4}{x_5}{x_6}{i}, s} -> \lrangle{i ; \map{x_1}{x_2}{x_3}{x_4}{x_5}{x_6}{i}, s'}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ \}}
{\lrangle{\mathtt{MEM}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ v_2 ; < tl > \} \\ \compare~v_1~v_2 = 1
    \\ s' = s[y \mapsto tl] \\ \lrangle{\mathtt{MEM}~x_1~y} -> \lrangle{b, s}}
{\lrangle{\mathtt{MEM}~x_1~x_2} -> \lrangle{b, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ v_2 ; < tl > \} \\ \compare~v_1~v_2 = 0}
{\lrangle{\mathtt{MEM}~x_1~x_2} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ v_2 ; < tl > \} \\ \compare~v_1~v_2 = -1}
{\lrangle{\mathtt{MEM}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ \elt{k}{v} ; < m > \} \\ \compare~v_1~k = 1
    \\ s' = s[y \mapsto m] \\ \lrangle{\mathtt{MEM}~x_1~y} -> \lrangle{b, s}}
{\lrangle{\mathtt{MEM}~x_1~x_2} -> \lrangle{b, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ \elt{k}{v} ; < m > \} \\ \compare~v_1~k = 0}
{\lrangle{\mathtt{MEM}~x_1~x_2} -> \lrangle{\true, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \{ \elt{k}{v} ; < m > \} \\ \compare~v_1~k = -1}
{\lrangle{\mathtt{MEM}~x_1~x_2} -> \lrangle{\false, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{NIL}~t} -> \lrangle{\{\}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{NONE}~t} -> \lrangle{\none, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{PACK}} -> \lrangle{\mathsf{pack}~v, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2}
{\lrangle{\mathtt{PAIR}~x_1~x_2} -> \lrangle{\pair{v_1}{v_2}, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{RIGHT}~t~x} -> \lrangle{\mathtt{Right}~v, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{SIZE}~x} -> \lrangle{\length~v, s}}

\vspace{0.5cm}

\inference{s[x] = \{\}}
{\lrangle{\mathtt{SIZE}~x} -> \lrangle{0, s}}

\vspace{0.5cm}

\inference{s[x] = \{ v ; < tl >\} \\ s' = s[y \mapsto tl] \\
    \lrangle{\mathtt{SIZE}~y} -> \lrangle{n, s}}
{\lrangle{\mathtt{SIZE}~x} -> \lrangle{1 + n, s}}

\vspace{0.5cm}

\inference{s[x] = \{ \elt{k}{v} ; < tl >\} \\ s' = s[y \mapsto tl] \\
    \lrangle{\mathtt{SIZE}~y} -> \lrangle{n, s}}
{\lrangle{\mathtt{SIZE}~x} -> \lrangle{1 + n, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ s[x_3] = v_3 \\ v_1 + v_2 < \length~v_3}
{\lrangle{\mathtt{SLICE}~x_1~x_2~x_3} ->
    \lrangle{\some{(\mathsf{slice}~v_3~v_1~v_2)}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ s[x_3] = v_3 \\ v_1 + v_2 >= \length~v_3}
{\lrangle{\mathtt{SLICE}~x_1~x_2~x_3} -> \lrangle{\none, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{SOME}~x} -> \lrangle{\some{v}, s}}

\vspace{0.5cm}

\inference{}
{\lrangle{\mathtt{UNIT}} -> \lrangle{\unit, s}}

\vspace{0.5cm}

\inference{s[x] = v}
{\lrangle{\mathtt{UNPACK}~t~x} -> \lrangle{\mathsf{unpack}~t~v, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \false \\ s[x_3] = \{\}}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{\}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \false \\ s[x_3] = \{\}}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ v_1 \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ s[x_3] = \{ v_3 ; < tl >\} \\
    \compare~v_1~v_3 = 1 \\ s' = s[y \mapsto tl] \\
    \lrangle{\mathtt{UPDATE}~x_1~x_2~y} -> \lrangle{tl', s}}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ v_3 ; < tl' > \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \false \\ s[x_3] = \{ v_3 ; < tl >\} \\
    \compare~v_1~v_3 = 0}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{tl, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \true \\ s[x_3] = \{ v_3 ; < tl > \} \\
    \compare~v_1~v_3 = 0}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ v_3 ; < tl > \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \false \\ s[x_3] = \{ v_3 ; < tl > \} \\
    \compare~v_1~v_3 = -1}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ v_3 ; < tl > \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \true \\ s[x_3] = \{ v_3 ; < tl > \} \\
    \compare~v_1~v_3 = -1}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ v_1 ; < \{ v_3 ; < tl > \}
        > \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \none \\ s[x_3] = \{\}}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{\}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \some{v_2} \\ s[x_3] = \{\}}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ \elt{v_1}{v_2} \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = v_2 \\ s[x_3] = \{ \elt{k}{v} ; < m >\} \\
    \compare~v_1~k = 1 \\ s' = s[y \mapsto m] \\
    \lrangle{\mathtt{UPDATE}~x_1~x_2~y} -> \lrangle{m', s}}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ \elt{k}{v} ; < m' > \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \none \\ s[x_3] = \{ \elt{k}{v} ; < m >\} \\
    \compare~v_1~k = 0}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{m, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \some{v_2} \\ s[x_3] = \{ \elt{k}{v} ; < m > \} \\
    \compare~v_1~v_3 = 0}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ \elt{k}{v} ; < m > \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \none \\ s[x_3] = \{ \elt{k}{v} ; < tl > \} \\
    \compare~v_1~v_3 = -1}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ \elt{k}{v} ; < m > \}, s}}

\vspace{0.5cm}

\inference{s[x_1] = v_1 \\ s[x_2] = \some{v_2} \\ s[x_3] = \{ \elt{k}{v} ; < m > \} \\
    \compare~v_1~v_3 = -1}
{\lrangle{\mathtt{UPDATE}~x_1~x_2~x_3} -> \lrangle{\{ \elt{v_1}{v_2} ; < \{ \elt{k}{v} ; < m > \} > \}, s}}
\end{document}
